var { ExtensionCommon } = ChromeUtils.import("resource://gre/modules/ExtensionCommon.jsm");
var { Services } = ChromeUtils.import("resource://gre/modules/Services.jsm");
var {fixIterator} = ChromeUtils.import("resource:///modules/iteratorUtils.jsm"); // for fixIterator

//Define API
var checkAndSendApi = class extends ExtensionCommon.ExtensionAPI {
  getAPI(context) {
    return {
      checkAndSendApi: {
        getAttachments: async function () {
          let rw = Services.wm.getMostRecentWindow("msgcompose");
          let ret = [];
          if (rw) {
            ret = CheckAndSend.getAttachmentInfo(rw);
          }
          return ret;
        },
        
        getHistoryAddressBookName: async function () {
          let rw = Services.wm.getMostRecentWindow("msgcompose");
          let historyURI = "";
          let ret = "";
          if (rw) {
            let subDirs = Components.classes["@mozilla.org/abmanager;1"]
                          .getService(Components.interfaces.nsIAbManager).directories;
            try {
              historyURI = Services.prefs.getStringPref("mail.collect_addressbook");
            } catch (ex) {
            }
			let dir;
            for (dir of fixIterator(subDirs, Components.interfaces.nsIAbDirectory)) {
              try {
                let uri = dir.URI;
                if (uri == historyURI) {
                  ret = dir.dirName;
                  break;
                }
              } catch(e) {
              }
			}
          }
          
          return ret;
          
        }
      },
    };
  }
};

var CheckAndSend = {
  getAttachmentInfo: function(win) {
    let bucket = win.document.getElementById('attachmentBucket');
	let rowCount = bucket.itemCount;
    let attachments = [];
    for (let i = 0; i < rowCount; i++) {
      let item = bucket.getItemAtIndex(i);
      if (item) {
        let attachment = {};

        attachment.name = item.getAttribute("name");

        let url = item.attachment.url;
    	let ios = Components.classes["@mozilla.org/network/io-service;1"]
                    .getService(Components.interfaces.nsIIOService);
        let fileHandler = ios.getProtocolHandler("file")
            .QueryInterface(Components.interfaces.nsIFileProtocolHandler);
        var file = fileHandler.getFileFromURLSpec(url);
	  	attachment.size = file.fileSize;
        attachments.push(attachment);
      }
    }
    return attachments;
  }
};